// A regular expression to identify tags for image files in 
// HTML, assuming the HTML code is reasonably well-formed.
String re = "<img[^>]+src=\"([^\"]*)\"";

// For simplicity, express URLs in three parts: the server, the
// directory, and the file.  Of course, we could pull URLs apart
// using regular expressions too...

//String urlbase = "https://www.student.cs.uwaterloo.ca/";
//String urlpath = "~cs116/x/";
//String urlfile = "";
String urlbase = "http://www.amazon.com/";
String urlpath = "";
String urlfile = "";

PImage[] images;
int showing = -1;

void setup()
{
  size( 500, 500 );
  images = new PImage[0];
  
  String[] lines = loadStrings( urlbase + urlpath + urlfile );
  for( int idx = 0; idx < lines.length; ++idx ) {
    String[] ms = match( lines[idx], re );
    if( ms != null ) {
      String imgpath = ms[1];
      PImage img = null;
      if( imgpath.startsWith( "/" ) ) {
        // Absolute path.
        img = loadImage( urlbase + imgpath );
      } else if( imgpath.contains( ":" ) ) {
        // Assume a full URL with server
        img = loadImage( imgpath );
      } else {
        // Assume a relative path.
        img = loadImage( urlbase + urlpath + imgpath );
      }
      
      if( img != null ) {
        images = (PImage[])append( images, img );
      }
    }
  }
  
  if( images.length > 0 ) {
    showing = 0;
  }
}

void draw()
{
  background( 0 );
  image( images[showing], 0, 0 );
}

void keyPressed()
{
  if( key == ' ' ) {
    showing = (showing + 1) % images.length;
  }
}
