// A few additional word puzzles that don't appear in the lab.

// Store an array of all English words.
String[] words;

// Which mode are we currently in?
int mode = 0;
// How many modes are there in all?
int num_modes = 4;

void setup()
{
  size( 300, 600 );
  words = loadStrings( "sowpods.txt" );
  textSize( 24 );
}

// This one is provided: find all the English words
// that end in "mt".
String[] getWords_0()
{
  String[] ret = {};

  for ( int idx = 0; idx < words.length; ++idx ) {
    if ( words[idx].endsWith( "mt" ) ) {
      ret = append( ret, words[idx] );
    }
  }

  return ret;
}

// Find all words of even length for which the second half
// of the word is the same as the first half (example: "dodo").
String[] getWords_1() 
{
  String[] ret = {};

  for ( int idx = 0; idx < words.length; ++idx ) {
    String w = words[idx];
    int l = w.length();
    if ( l % 2 == 0 ) {
      if ( w.substring( 0, l/2 ).equals(
        w.substring( l/2, l ) ) ) {
        ret = append( ret, words[idx] );
      }
    }
  }

  return ret;
}

// Find all palindromes of length 6 or more.
String[] getWords_2() 
{
  String[] ret = {};

  for ( int idx = 0; idx < words.length; ++idx ) {
    String w = words[idx];
    if ( w.length() >= 6 ) {
      // Build a backwards copy of the word
      String bw = "";
      for ( int x = w.length() - 1; x >= 0; --x ) {
        bw = bw + w.charAt( x );
      }
      if ( w.equals( bw ) ) {
        ret = append( ret, w );
      }
    }
  }

  return ret;
}

// Find all words that contain all of "x", "y" and "z".
String[] getWords_3() 
{
  String[] ret = {};

  for ( int idx = 0; idx < words.length; ++idx ) {
    String w = words[idx];
    if ( w.contains( "x" ) && w.contains( "y" ) && w.contains( "z" ) ) {
      ret = append( ret, w );
    }
  }

  return ret;
}

// You don't need to change anything in the draw() function.
void draw()
{
  background( 50 );

  fill( 200, 200, 255 );
  text( "Mode " + mode, 10, 30 );

  fill( 255, 255, 255 );
  String[] result = {};

  if ( mode == 0 ) {
    result = getWords_0();
  } else if ( mode == 1 ) {
    result = getWords_1();
  } else if ( mode == 2 ) {
    result = getWords_2();
  } else if ( mode == 3 ) {
    result = getWords_3();
  }

  for ( int idx = 0; idx < result.length; ++idx ) {
    text( result[idx], 10, 80 + idx * 30 );
  }

  noLoop();
}

// Press a key to cycle through modes.
void keyPressed()
{
  mode = (mode + 1) % num_modes;
  loop();
}